package dacSketches.ejbDynamicBinding.client;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;

import dacSketches.ejbDynamicBinding.ejb.staticLiaison.StaticLiaisonHome;
import dacSketches.ejbDynamicBinding.ejb.staticLiaison.StaticLiaisonRemoteProxy;


public class StaticLiaisonClient
{
	public static void main( String[] args )
	{
		try
		{
			Context initial = new InitialContext();
			Context env = (Context) initial.lookup( "java:comp/env" );
			Object obj = env.lookup( "ejb/StaticLiaison" );

			StaticLiaisonHome home =
				(StaticLiaisonHome) PortableRemoteObject.narrow( obj, StaticLiaisonHome.class);

			StaticLiaisonRemoteProxy proxy = home.create();

			String testString = new String( "the quick brown fox..." );
			String resultString = (String) proxy.forward( testString );

			System.out.println( "submit: " + testString );
			System.out.println( "result: " + resultString );
			System.exit( 0 );
		}
		catch (Exception ex)
		{
			System.err.println( "Caught an unexpected exception!" );
			ex.printStackTrace();
		}
	}
}

