package dacSketches.ejbDynamicBinding.ejb.converter;

import java.rmi.RemoteException;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import javax.ejb.SessionBean;
import javax.ejb.SessionContext;
import javax.ejb.CreateException;

import dacSketches.ejbDynamicBinding.ejb.common.SessionAdapter;
import dacSketches.ejbDynamicBinding.ejb.dynamicLiaison.ConverterInterface;


public class UpperCaseConverterBean
	extends SessionAdapter
	implements ConverterInterface
{
	private String					beanName;
	private InitialContext			context;

	private final String beanNameKey = new String( "beanName" );

	//	Method(s) defined in ConverterInterface.
	public String process( String obj )
		throws RemoteException
	{
		if (String.class == obj.getClass())
		{
			String in = (String) obj;
			return in.toUpperCase();
		}
		else
		{
			return obj;
		}
	}
		
	public void ejbCreate()
		throws CreateException
	{
		super.ejbCreate();

		String myMethod = "ejbCreate";
		log( beanName, myMethod, "Invoked" );

		try
		{
			Context ictx = new InitialContext();
			Context env = (Context) ictx.lookup( "java:comp/env" );

			beanName = (String) env.lookup( beanNameKey );
		}
		catch (NamingException e)
		{
			log( beanName, myMethod, e.getMessage() );
			throw new CreateException( e.getMessage() );
		}
		finally
		{
			log( beanName, myMethod, "Finished" );
		}
	}

	public void ejbRemove()
	{
		String myMethod = "ejbRemove";
		log( beanName, myMethod, "Invoked" );
		log( beanName, myMethod, "Finished" );
	}
}

