package dacSketches.ejbDynamicBinding.ejb.staticLiaison;

import java.rmi.RemoteException;

import javax.ejb.SessionBean;
import javax.ejb.SessionContext;
import javax.ejb.CreateException;

import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import javax.rmi.PortableRemoteObject;

import dacSketches.ejbDynamicBinding.ejb.common.SessionAdapter;
import dacSketches.ejbDynamicBinding.ejb.converter.UpperCaseConverterHome;
import dacSketches.ejbDynamicBinding.ejb.converter.UpperCaseConverterRemoteProxy;

/*
 *	A stateless session bean that demonstrates static binding.
 */

public class StaticLiaisonBean
	extends SessionAdapter
{
	private String								beanName;
	private UpperCaseConverterRemoteProxy		proxy = null;
	private InitialContext						context = null;

	private final String beanNameKey = new String( "beanName" );

	public String forward( String obj )
		throws RemoteException
	{
		String myMethod = "forward";
		log( beanName, myMethod, "Invoked" );

		try
		{
			return proxy.process( obj );
		}
		finally
		{
			log( beanName, myMethod, "Finished" );
		}
	}
		
	//  Methods defined in SessionBean.

	public void ejbCreate()
		throws CreateException
	{
		super.ejbCreate();
		
		String myMethod = "ejbCreate";
		log( beanName, myMethod, "Invoked" );

		try
		{
			Context ictx = new InitialContext();
			Context env = (Context) ictx.lookup( "java:comp/env" );

			beanName = (String) env.lookup( beanNameKey );

			Object obj = env.lookup( "ejb/TargetBean" );
			UpperCaseConverterHome home =
				(UpperCaseConverterHome) PortableRemoteObject.narrow( obj,
					UpperCaseConverterHome.class );
			proxy = home.create();
		}
		catch (NamingException e)
		{
			log( beanName, myMethod, e.getMessage() );
			throw new CreateException( e.getMessage() );
		}
		catch (RemoteException e)
		{
			log( beanName, myMethod, e.getMessage() );
			throw new CreateException( e.getMessage() );
		}
		finally
		{
			log( beanName, myMethod, "Finished" );
		}
	}
}

